/***************************************************************************
                          screen.c  -  description
                             -------------------
    begin                : Thu Dec 23 2004
    copyright            : (C) 2004 by Hubert Vansteenhuyse
    email                : hvansteenhuyse@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "subnet.h"
FILE    *fout;
WINDOW  *wnd = NULL;
char    *columns[] = { "#", "NET", "BCAST", "RANGE" };
int     x_colpos[4];

char	foundres[128];
char    buf[1024 * 2], ipbuf[32];

int     THESCREEN = 0,		//the current screen
		THETAB = 0,			//selector for cidr, mask, subnet input
		taborder = 0,     //input selector (CIDR, subnets, mask)
        Subnets = 0;
        
int     x_mask = 0,
        x_hosts = 0,
        box_canceled = 0,
        dlgbox_canceled = 0;

int     ycenter = 0, xcenter = 0, helpbegin = 0;

long    netstartcounter = 1;

char *helper[] = {
    // l = left, r = right, c center, - line
    "cSUBNET CALCULATOR HELP.",
    "cThis software can be used to calculate TCP/IP version 4 subnets.",
    "-",
    "lCHANGING THE CIDR, NETMASK #NETWORKS or #HOSTS PARAMETERS:",
    "l\t- Use keys TAB/LEFT/RIGHT to move the cursor between the parameters.",
    "l\t- Type the new parameter which are all numerical values/keys.",
    "l",
    "lSCROLLING OR SEARCHING THE SUBNETLIST:",
    "l\t- Use keys UP/DOWN/PAGEUP/PAGEDOWN to scroll the list.",
    "l\t- Type f to find the subnet of an ip address.",
    "l\t- Type j to jump to a subnet.",
    "l",
    "lDIALOG BOXES:",
    "l\t- Type the value using any NUMERICAL keys and the . key.",
    "l\t- Key ENTER accepts the value. Keys TAB/ESCAPE cancels the value.",
    "l \t- Keys DELETE/BACKSPACE removes the charachter before the cursor.",
    "l",
    "l OTHERS:",
    "l\tSPACE...redraws the screen (usefull in xterminals)",
    "l\th.....help                    q.......quit",
    "l\tw.....write to file           v.......vocabularium",
    "-",
    "cThis is free software. hvansteenhuyse@yahoo.com",
    "c[PRESS ANY KEY]",
    NULL 
};

char *vocabularium[] = {
    "cVOCABULARIUM",
    "-",
    "lSUBNETTING:",
    "lBorrowing some bits of the hostpart from an ip address to create more networks",
    "lis subnetting. As a result a large network will be chunked in smaller subnets.",
    "lAnother method is transparent bridging which operates on OSI LAYER 2 while",
    "lsubnetting operates on LAYER 3.",
    "l",
    "lCIDR (Classless Inter Domain Routing).",
    "lThis notation is a way to represent an ip address and it's subnetmask.",
    "lConventional: 127.0.0.1 255.255.0.0 Cidr: 127.0.0.1 / 16",
    "l",
    "lMAGIC NUMBER:",
    "lThis is 256 minus the last nonzero dot separated digit group in the mask,",
    "lwhich can be used to calculate the subnet chunks (this software doesn't).",
    "lMSK: 255.255.255.254 MN: 256-254=2. MSK: 255.224.0.0 MN: 256-224=32",
    "l",
    NULL
};
/*************************************************************************************************************************
**************************************************************************************************************************
*************************************************************************************************************************/
    



void reInitScreen(){ endwin(); wnd = initscr(); }
void SIGNAL_RESIZE(int n){ reInitScreen(); updateScreen(); refresh(); }

int center(int y, char *str){ int x = (wnd->_maxx - strlen(str)) / 2; mvaddstr(y, x, str); return x; }
int left(int y, char *str){ mvaddstr(y, 0, str); return 0; }
int right(int y, char *str){ int x = 1 + wnd->_maxx - strlen(str); mvaddstr(y, wnd->_maxx, " "); mvaddstr(y, x, str); return x; }

char* format(char *fmt, ...){ va_list args; va_start(args, fmt); vsprintf(buf, fmt, args); va_end(args); return buf; }

void drawhorline(int y){ int c; move(y, 0); for(c = 0; c <= wnd->_maxx; c++) addch(ACS_HLINE); move(y, 0); }

void drawverline(int y,int x){
    int _x=x,_y=y;
   	while(y <= wnd->_maxy){
   	   	move(y, x);
   	    addch(ACS_VLINE);
   	    y++;
   	}    
   	move(_y, _x);
}

void drawbox(int y,int x, int height, int width){
    int v, h;
    for(v = y; v < y + height; v++){
        move(v, x); for(h = 0; h <= width; h++) addch(' ');
    }

    move(y, x); addch(ACS_ULCORNER); for(h = 0; h <= width - 2; h++) addch(ACS_HLINE); addch(ACS_URCORNER);
    move(y + 2, x); for(h = 0; h <= width; h++) addch(ACS_HLINE);
    move(y + height, x); addch(ACS_LLCORNER); for(h = 0; h <= width - 2; h++) addch(ACS_HLINE); addch(ACS_LRCORNER);
   	for(v = y + 1; v < y + height; v++){ move(v, x); addch(ACS_VLINE); }
   	for(v = y + 1; v < y + height; v++){ move(v, x + width); addch(ACS_VLINE); }
    move(y + 1, x + 2);
}

//inputbox for ip addresses **************************************************************************************
static char ipbox_title[64];
static char ipbox_buf[64];
char* ipbox(char *title, char firstdigit){
   	char in;
    ycenter = (wnd->_maxy - 6) / 2;
    xcenter = (wnd->_maxx - 30) / 2;
   	
  	if(title != NULL){
  	   box_canceled = 0;
       sprintf(ipbox_title, " %s", title);
       memset(ipbox_buf, 0, 64);
       sprintf(ipbox_buf, "%c", firstdigit);
    }    
  	
    drawbox(ycenter, xcenter, 6, 30); addstr(ipbox_title);
  	mvaddstr(ycenter + 5, xcenter + 2, "keys: enter esc backspace");
  	mvaddstr(ycenter + 3, xcenter + 2, format("VALUE: %s", ipbox_buf));
  	
	if(title != NULL){
	    for(;;){
      		in = getinput();
      		if(in == ' '){ updateScreen(); continue; }
      		if(in == '\t' || in == 27){ box_canceled = 1; break; }
      		if(in == 13 || in == 10 ){ break; }
      		if(in == KEYBACK && strlen(ipbox_buf) > 0){
                ipbox_buf[strlen(ipbox_buf) - 1] = 0;
                mvaddstr(ycenter + 3, xcenter + 2, format("VALUE: %s ", ipbox_buf));
                mvaddstr(ycenter + 3, xcenter + 2, format("VALUE: %s", ipbox_buf));
                refresh();
            }
      		if((strlen(ipbox_buf) < 15) && (in == '.' || ISDIGIT(in))){
             	sprintf(ipbox_buf + strlen(ipbox_buf), "%c", in); 
             	mvaddstr(ycenter + 3, xcenter + 2, format("VALUE: %s", ipbox_buf));
            }   	
   		}
    }    
    
	if(title != NULL) memset(ipbox_title, 0, 64);
	return ipbox_buf;
}

//inputbox for digits **************************************************************************************
static char intbox_title[64];
static char intbox_msg[128];
static char intbox_buf[8];
char* intbox(char *title, char* msg, char firstdigit){
    int wdt;
   	char in;
   	
  	if(title != NULL){
       box_canceled = 0;
       sprintf(intbox_title, "%s", title);
       sprintf(intbox_msg, "%s", msg);
       memset(intbox_buf, 0, 8);
       sprintf(intbox_buf, "%c", firstdigit);
    }    

   	wdt = strlen(intbox_title) + 4;
   	if(strlen(intbox_msg) > wdt) wdt = strlen(intbox_msg) + 4; 
   	
    ycenter = (wnd->_maxy - 7) / 2;
    xcenter = (wnd->_maxx - wdt) / 2;
  	
    drawbox(ycenter, xcenter, 7, wdt); addstr(intbox_title);
  	mvaddstr(ycenter + 3, xcenter + 2, intbox_msg);
  	mvaddstr(ycenter + 6, xcenter + 2, "keys: enter esc backspace");
  	mvaddstr(ycenter + 4, xcenter + 2, format("VALUE: %s", intbox_buf));
  	
	if(title != NULL){
	    for(;;){
      		in = getinput();
      		if(in == ' '){ updateScreen(); continue; }
      		if(in == '\t' || in == 27){ box_canceled = 1; break; }
      		if(in == 13 || in == 10){ break; }
      		if(in == KEYBACK && strlen(intbox_buf) > 0){
                intbox_buf[strlen(intbox_buf) - 1] = 0;
                mvaddstr(ycenter + 4, xcenter + 2, format("VALUE: %s ", intbox_buf));
                mvaddstr(ycenter + 4, xcenter + 2, format("VALUE: %s", intbox_buf));
                refresh();
            }
      		if((strlen(intbox_buf) < 8) && ISDIGIT(in)){
             	sprintf(intbox_buf + strlen(intbox_buf), "%c", in); 
             	mvaddstr(ycenter + 4, xcenter + 2, format("VALUE: %s", intbox_buf));
            }   	
   		}
    }    
    
	if(title != NULL) memset(intbox_title, 0, 64);
	return intbox_buf;
}


//Messagebox **************************************************************************************
static char mbox_title[64];
static char mbox_msg[128];
void messagebox(char *title, char *msg){
    int wdt;
        if(title){
            sprintf(mbox_title, title);
            sprintf(mbox_msg, msg);
        }
    	wdt = strlen(mbox_title) + 4;
    	if(strlen(mbox_msg) > wdt) wdt = strlen(mbox_msg) + 4;
       	ycenter = (wnd->_maxy - 5) / 2;
    	xcenter = (wnd->_maxx - wdt) / 2;
    
   	    drawbox(ycenter, xcenter, 5, wdt); addstr(mbox_title);
  	    mvaddstr(ycenter + 3, xcenter + 2, mbox_msg);
  	    mvaddstr(ycenter + 4, xcenter + 6, "Press any key...");
  	    
  	    if(title){
  	  	    getinput();
  	  	    memset(mbox_title, 0, 64);
  	    }
}

//dialoogbox voor alle karakters **************************************************************************************
static char dlgbox_title[64];
static char dlgbox_buf[128];
void dlgbox(char *title){
    int wdt, start;
   	char in;
   	
  	if(title != NULL){
       dlgbox_canceled = 0;
       sprintf(dlgbox_title, "%s", title);
       memset(dlgbox_buf, 0, 8);
    }    

   	wdt = wnd->_maxx;
   	if(wdt > 128 / 2) wdt = 128 / 2;
  	
    ycenter = (wnd->_maxy - 5) / 2;
    xcenter = (wnd->_maxx - wdt) / 2;
  	
    drawbox(ycenter, xcenter, 5, wdt); addstr(dlgbox_title);
  	mvaddstr(ycenter + 4, xcenter + 2, "keys: enter esc backspace");
  	if( strlen(dlgbox_buf) > (wdt - 4)) start = strlen(dlgbox_buf) - wdt + 4; else start = 0;
  	mvaddstr(ycenter + 3, xcenter + 2, dlgbox_buf + start);
  	
	if(title != NULL){
	    for(;;){
      		in = getinput();
      		if(in == ' '){ updateScreen(); /*continue;*/ }
      		if(in == '\t' || in == 27){ dlgbox_canceled = 1; break; }
      		if(in == 13 || in == 10){ break; }
      		if(in == KEYBACK && strlen(dlgbox_buf) > 0){
                dlgbox_buf[strlen(dlgbox_buf) - 1] = 0;
                if( strlen(dlgbox_buf) > (wdt - 4)) start = strlen(dlgbox_buf) - wdt + 4; else start = 0;
                mvaddstr(ycenter + 3, xcenter + 2, format("%s ", dlgbox_buf + start));
                mvaddstr(ycenter + 3, xcenter + 2, dlgbox_buf + start);
                refresh();
                continue;
            }
            if(in == KEYBACK) continue;
      		if(strlen(dlgbox_buf) < 128){
             	sprintf(dlgbox_buf + strlen(dlgbox_buf), "%c", in); 
             	if( strlen(dlgbox_buf) > (wdt - 4)) start = strlen(dlgbox_buf) - wdt + 4; else start = 0;
             	mvaddstr(ycenter + 3, xcenter + 2, dlgbox_buf + start);
            }   	
   		}
    }    
    
	if(title != NULL) memset(dlgbox_title, 0, 64);
}

/*************************************************************************************************************************
**************************************************************************************************************************
*************************************************************************************************************************/
void exitScreen(void){ endwin(); }

int initScreen(void){
  if( NULL != (wnd = initscr()) ){
    keypad(stdscr, TRUE);
    noecho();
    signal(SIGWINCH, SIGNAL_RESIZE);
    memset(&buf, 0, 1024);
    return 1;
   
  }
  return 0;
}

void input(void){
  int sw_exit = 0, in, xpos, val;
  long lval;
      while(sw_exit == 0){
          xpos = 1;
          in = getinput();

          if(THESCREEN == 0 && ISDIGIT(in) ){
              switch(THETAB){
                  case 0:	//cidr
                  	if( isvalidip(ipbox("New IP address", in)) ){
                        if(box_canceled){ updateScreen(); continue; }
                   		ip = iptolong(ipbox_buf);
                   		netstartcounter = 1;
                    	switch( (int)getipclass(ip) ){
                    	    case (int)'A':
                    	        mask = iptolong("255.0.0.0");
                    	        break;
                    	        
                    	    case (int)'B':
                    	        mask = iptolong("255.255.0.0");
                    	        break;
                    	        
                    	    case (int)'C':
                    	        mask = iptolong("255.255.255.0");
                    	        break;
                        }    
            		}  		
            		else{
            		    if(box_canceled){ updateScreen(); continue; }
            		    updateScreen();
            		    messagebox(	format("INVALID IP \"%s\"", ipbox_buf),
                  							"Use digits(0-255) with format x.y.w.z");
            		}    
                  	updateScreen();
                    break;

                  case 1: //cidr mask
                    	switch( (int)getipclass(ip) ){
                    	    case (int)'A':
                    	        val = atoi(intbox("New subnetmask", "Valid masks are 8 or from 10 to 30", in));
                    	        if(box_canceled){ updateScreen(); continue; }
                    	        if(val == 8 || (val >= 10 && val <= 30)){
                    	        	mask = cidrtomask(val);
                    	        	netstartcounter = 1;
                    	        }else{
                        		    updateScreen();
                        		    messagebox(	format("INVALID MASK \"%s\"", intbox_buf),
                              							"The IP is class A: Valid masks are 8 or from 10 to 30");
                                 }
                    	        break;
                    	        
                    	    case (int)'B':
                    	        val = atoi(intbox("New subnetmask", "Valid masks are 16 or from 18 to 30", in));
                    	        if(box_canceled){ updateScreen(); continue; }
                    	        if(val == 16 || (val >= 18 && val <= 30)){
                    	        	mask = cidrtomask(val);
                    	        	netstartcounter = 1;
                   	        	}else{
                        		    updateScreen();
                        		    messagebox(	format("INVALID MASK \"%s\"", intbox_buf),
                              							"The IP is class B: Valid masks are 16 or from 18 to 30");
                                 }
                    	        break;
                    	        
                    	    case (int)'C':
                    	        val = atoi(intbox("New subnetmask", "Valid masks are 24 or from 26 to 30", in));
                    	        if(box_canceled){ updateScreen(); continue; }
                    	        if(val == 24 || (val >= 26 && val <= 30)){
                    	        	mask = cidrtomask(val);
                    	        	netstartcounter = 1;
                   	        	}else{
                        		    updateScreen();
                        		    messagebox(	format("INVALID MASK \"%s\"", intbox_buf),
                              							"The IP is class C: Valid masks are 24 or from 16 to 30");
                                 }
                    	        break;
                	        default:
                	            	val = atoi(intbox("New subnetmask", "TODO: identify valid masks CLASS D & F", in));
                	            	if(box_canceled){ updateScreen(); continue; }
                    	        	mask = cidrtomask(val);
                	            
                        }    
                  	updateScreen();
                  	break;
                                       
                  case 2:	//mask format 255.255.0.0
                  	if( isvalidmask( ipbox("New subnetmask", in)) ){
                  	    if(box_canceled){ updateScreen(); continue; }
                   		mask = iptolong(ipbox_buf);
                   		netstartcounter = 1;
                    }
            		else{
            		    if(box_canceled){ updateScreen(); continue; }
            		    updateScreen();
            		    messagebox(	format("INVALID SUBNETMASK \"%s\"", ipbox_buf),
                  							"Check net<->host bits or/and use digits(0-255) with format x.y.w.z");
                    }
                  	updateScreen();
                    break;
                  case 3:	//#subnets
                    lval = atoi(intbox("# networks wanted", "I will look for the closest amount of subnets...", in));
                    if(!box_canceled){ useamount_net( lval ); netstartcounter = 1; }
                    updateScreen();
                   	break;
                  case 4:	//#hosts
                    lval = atoi(intbox("# hosts wanted", "I will look for the closest amount of hosts...", in));
                    if(!box_canceled){ useamount_host( lval ); netstartcounter = 1; }
                    updateScreen();
                    break;
              }
          }

          if(in == 'q'){ sw_exit = 1; continue; }
          if(in == ' '){ updateScreen(); continue; }
          if(in == 'h'){ THESCREEN = 1; updateScreen(); getinput(); THESCREEN = 0; updateScreen(); continue; }
          if(in == 'v'){ THESCREEN = 2; updateScreen(); getinput(); THESCREEN = 0; updateScreen(); continue; }
          if(in == '\t' || in == KEYR){ THETAB++; if(THETAB > 4){ THETAB = 0; }  updateScreen(); continue; }
          if(in == KEYL){ THETAB--; if(THETAB < 0){ THETAB = 4; }  updateScreen(); continue; }

          if(in == 'w'){//write to file
               dlgbox("Write to file. Give the filename...");
               if(dlgbox_canceled){ updateScreen(); continue; }
               fout = fopen(dlgbox_buf, "w");
               updateScreen();
               if(fout){
                   writefile(fout);
                   updateScreen();
                   fclose(fout);
               }else{
               }
          }


          if(in == 'j'){ //jump 
              lval = atoi(intbox("# Jump", "Type the network you want to see", 0));
              if(!box_canceled){ 
                   if(lval < 1 ) lval = 1;
                   if(lval > getnets()) lval = getnets();
                   netstartcounter = lval;
              }
              updateScreen(); 
              continue; 
          }

          if(in == 'f'){ //find the network of the ip 
              if( !isvalidip(ipbox("Find ip address", 0)) ){
         		    if(box_canceled){ updateScreen(); continue; }
           		    updateScreen();
           		    messagebox(	format("INVALID IP \"%s\"", ipbox_buf), "Use digits(0-255) with format x.y.w.z");
              }else{
                  if(!box_canceled){
         		    netstartcounter = findnet( iptolong(ipbox_buf) );
         		    if(netstartcounter == -1){
               			messagebox( "SUBNET NOT FOUND", format("The address %s belongs to a complete different network.", ipbox_buf));
               			netstartcounter = 1;
           			}else{
         		    	if(netstartcounter < 1) netstartcounter = 1;
         		    	sprintf(foundres, "[IP %s IS IN SUBNET %d]", ipbox_buf, (unsigned)netstartcounter);
       		    	}   	
         		  }    
              }    
              updateScreen(); 
              continue; 
          }
          
          if(in == KEYD){
              if(netstartcounter + 1 > getnets())
                  netstartcounter = getnets();
              else
                  netstartcounter++;
              updateScreen();
              continue;
          }
          if(in == KEYU){
              if(netstartcounter == 1)
                 netstartcounter = 1;
              else
                 netstartcounter--;
              updateScreen();
              continue;
          }

          if(in == PGD){ 
              if(wnd->_maxy - 7 < 0) continue;
              if(netstartcounter + wnd->_maxy - 7 > getnets()){
                   while(netstartcounter > getnets()){
                       netstartcounter++;
                   }
              }
              else
                   netstartcounter += wnd->_maxy - 7;
              updateScreen();
              continue; 
          }
          
          if(in == PGU){
              if(wnd->_maxy - 7 < 0) continue;
              if( netstartcounter - wnd->_maxy - 7 < 1)
                  netstartcounter = 1;
              else
                  netstartcounter -= wnd->_maxy - 7;
              updateScreen();
              continue;
          }
          //left(0, format("KEY %c    ", in));
      }
}

char range[128];
void updateScreen(void){
  long net, cast, curr, max;
  int pct, y, column, h = 0;
  long count;
  char **show, *hlp;
      erase();
      y = wnd->_cury;

      switch(THESCREEN){
          case 1://help
          case 2://vocabularium
              show = helper;
              if(THESCREEN == 2) show = vocabularium;
              while( NULL != (hlp = show[h]) ){
                  switch(hlp[0]){
                  case '-':
                      drawhorline(y);
                      break;
                  case 'l':
                      left(y, hlp + 1);
                      break;
                  case 'r':
                      right(y, hlp + 1);
                      break;
                  case 'c':
                      center(y, hlp + 1);
                      break;
                  default:
                      left(y, hlp + 1);
                  }
                  h++;
                  y++;
              };
              break;
              
          default://subnet list
              //titels
              left(y, format(" SUBNET CALCULATOR version %d.%d", VERSION_HI, VERSION_LO));
              right(y, "[h]help, [q]quit "); y++;
              drawhorline(y);  y++;

              left(y, format(" cidr: %s / %d", longtoip(ip), calcbits(mask) )); x_mask = right(y, format("netmask: %s ", longtoip(mask))); y++;
              left(y, format(" #networks: %u", getnets())); x_hosts = right(y, format("#hosts: %d ", gethosts())); y++; 
              left(y, format(" magic number: %d ", magicnumber())); center(y, format("#subnetbits: %d", getsubnetbits())); right(y, format("class %c [%s] ", getipclass(ip), iptype(ip) )); y++;
              drawhorline(y);
              if(strlen(foundres))
                  center(y, foundres);
              else
                  center(y, format("%s", getbitsofip()));
              y++;
              memset(foundres, 0, 128);
              
              //maak de lijst
              column = (int)(wnd->_maxx - 80) / 4;
              if(column < 0) column = 0;
              x_colpos[0] = 0; mvaddstr(y, x_colpos[0], columns[0]);  
              x_colpos[1] = column + x_colpos[0] + 10; drawverline(y, x_colpos[1] - 2); mvaddstr(y, x_colpos[1], columns[1]);
              x_colpos[2] = column + x_colpos[1] + 18; drawverline(y, x_colpos[2] - 2); mvaddstr(y, x_colpos[2], columns[2]);
              x_colpos[3] = column + x_colpos[2] + 18; drawverline(y, x_colpos[3] - 2); mvaddstr(y, x_colpos[3], columns[3]);
              
              y++;
              drawhorline(y);

              y++;
              count = netstartcounter;
              while(y <= wnd->_maxy){
                  net = ipcalcnet(count);
                  cast = ipcalcbcast(count);
                  mvaddstr( y, x_colpos[0], format("%u", count) );
                  mvaddstr( y, x_colpos[1], longtoip(net) );
                  mvaddstr( y, x_colpos[2], longtoip(cast) );
                  memset(range, 0, 128);
                  sprintf(range, "%s - ", longtoip(net + 1));
                  sprintf(range + strlen(range), "%s", longtoip(cast - 1));
                  mvaddstr( y, x_colpos[3], range);
                  count++;
                  y++;
                  if(count > getnets()) break;
              };
              curr = netstartcounter + y - 9;
              max = getnets();
              pct = PROCENT(curr, max);
              mvaddstr(6, x_colpos[0] + 1, format("(%d%%)", pct ) );  

              if(THETAB == 0) move(2, 7);
              if(THETAB == 1) move(2, strlen(format("cidr:  %s / %d", longtoip(ip), calcbits(mask))) - 1);
              if(THETAB == 2) move(2, x_mask + 9);
              if(THETAB == 3) move(3, 12);
              if(THETAB == 4) move(3, x_hosts + 8);
      }        
      
      if(strlen(ipbox_title)) ipbox(NULL, 0);	//redraw the ip input box
      if(strlen(intbox_title)) intbox(NULL, NULL, 0);	//redraw the integer input box
      if(strlen(mbox_title)) messagebox(NULL, NULL);	//redraw the message box
      if(strlen(dlgbox_title)) dlgbox(NULL);	//redraw the dialog box
      refresh();
}



void histogram(unsigned long curr, unsigned long max){
    float pct = PROCENT(curr, max);
    char    *htitle = "[WRITING TO FILE...]",
            hist[30];
    int     __ycenter = (wnd->_maxy - 5) / 2,
            __xcenter = (wnd->_maxx - 34) / 2,
            cnt = (int)(CUR_PROCENT(pct, 20) + .5),
            stars = cnt;
            
         memset(hist, 0 , 30);
         sprintf(hist + strlen(hist), "(");
         while(stars){ sprintf(hist + strlen(hist), "*"); stars--; }
         stars = 20 - cnt;
         while(stars){ sprintf(hist + strlen(hist), "."); stars--; }
         sprintf(hist + strlen(hist), ") %.2f%%", pct);
         
         drawbox(__ycenter, __xcenter, 5, 34);
         mvaddstr(__ycenter + 1, __xcenter + 2, htitle);
         mvaddstr(__ycenter + 3, __xcenter + 2, hist);
         move(__ycenter + 4, __xcenter + 1);
         refresh();
}

